import numpy as np
from tensorflow import keras
from keras import models
from keras import layers
import copy
from lammps import lammps

def one_hot(n, nmax):
    v = np.zeros(nmax)
    v[n] = 1.
    return v.reshape(1, nmax)

def reset_env(SIZE):
    lmp = lammps()
    lmp.file("intestine_after_learning.in")
    action = np.random.randint(0, SIZE)
    string_action = "variable index equal " + str(action)
    lmp.command(string_action)
    lmp.command("run 20000")
    v_com = lmp.extract_compute("reward",0,1)
    com = v_com[0]
    v_state = one_hot(action, SIZE)
    #after the action, it becomes the state
    return lmp, v_state, com

def step_env(lmp, action, old_com):
    string_action = "variable index equal " + str(action)
    lmp.command(string_action)
    lmp.command("run 10000")
    v_com = lmp.extract_compute("reward",0,1)
    new_com = v_com[0]
    v_state = one_hot(action, SIZE)
    reward = new_com - old_com
    return v_state, new_com, reward

#model_10000.h5 is the model produced during learning
model = keras.models.load_model('model_10000.h5')
SIZE = 10
lmp, s, com = reset_env(SIZE)

for i in range(20):
    a = np.argmax(model.predict(s))
    new_s, com, r = step_env(lmp, a, com)
    print(s,'-->', a, ':  reward=', r)
    s = new_s.copy()